/*******************************************************************************
 * Copyright (c) 2008 Intel Corporation.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Rodolfo Kohn - initial API and implementation
 *    Marcelo Lorenzatti, Miriam Estela - Management of multiple configurations 
      and filters .
 ******************************************************************************* 
 Product name: Plugin Extension for CIM  
 Creation date: Oct-24-2008
 Description:
 This module reads the client configuration parameters from /usr/local/etc/
 pec.conf and provides it in an array each parameter

 Modification History
 09/24/2008      Marcelo Lorenzati    Module creation
********************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

#include "libpec_configurationmanagement.h"

/**/
char *configurationArray[CONF_ARRAY_MAX]; 

int pecConfigurationManagementInit( void )
{
FILE * fp;
size_t len = 0;
ssize_t read;
int index = 0;
char *trailSymbol;

    fp = fopen(CONF_FILEPATH, "r");
    if (fp == NULL) { return -1; }

    while( ((read = getline(&configurationArray[index], &len, fp)) != -1) && (index < (CONF_ARRAY_MAX - 1)))
    {
        while ((trailSymbol = strrchr(configurationArray[index], '\n')) != NULL) { *trailSymbol = '\0'; }
        while ((trailSymbol = strrchr(configurationArray[index], ' ')) != NULL) { *trailSymbol = '\0'; }
        index++;
    }
    configurationArray[index] = NULL;

    return 0;
}

char *pecConfigurationManagementGetValue( char *ptr )
{
int index = 0;
char *configvalue, *trailsymbol;
    
    while ((configurationArray[index] != NULL) && (index < (CONF_ARRAY_MAX - 1)))
    {
        configvalue = strchr( configurationArray[index], '=');
        if (configvalue != NULL)
        {
            if ( strncmp(ptr, configurationArray[index], configvalue - configurationArray[index] ) == 0)
            {
                configvalue++; 
                return configvalue;
            } 
        }
        index++;
    }

return NULL;
}

/*To test functionality - to be erased*/
/*
int main(int argc, char **argv)
{
char *ptr;

    printf("libray test 2\n");
    if (init() != 0)
    {
        printf("Could not open configuration management\n");
        exit(-1);
    }
    
    printf("Configuration management Opened\n");   

    printf("Looking for configuration value for: %s\n", argv[1]); 

    ptr = getValue(argv[1]);
    
    if (ptr == NULL)
    {
        printf("Unexisting configuration in file\n");
    }
    else
    {
        printf("Configuration value = %s\n", ptr);
    }

    exit(0);
}
*/   
