#!/usr/bin/perl

use strict;

open(MYFILE, "pec_plugin.conf") or die "Could not open: $!\n";

my $line = <MYFILE>;
my $count = 1;
    
while($line)
{
    if ($line =~ /^\[PLUGIN\]$/)
    {
        my %pluginvalues;
        $line = <MYFILE>;
        while($line && !($line =~ /^\[PLUGIN\]$/))
        {
            if ($line =~ /(^\S+)=(.*$)/)
            {
                if (!$2)
                {
                    if ($1 && ($1 eq "Frequency"))
                    {
                        $pluginvalues{$1} = "5";
                        print "Value for $1 missing, setting to default value = $pluginvalues{$1}\n";
                    }
                    elsif ($1 && ($1 eq "ProbableCause"))
                    {
                        $pluginvalues{$1} = "\"Default probable cause $count\"";
                        print "Value for $1 missing, setting to default value = $pluginvalues{$1}\n";
                        $count++;
                    }
                    else
                    {
                        print "Value for $1 missing, skipping to next plugin\n";
                        while($line && !($line =~ /^\[PLUGIN\]$/))
                        {
                            $line = <MYFILE>;
                        }
                    }
                    
                }
		else
		{
                $pluginvalues{$1} = $2;
		}
            }
            $line = <MYFILE>;
        }

        if ($pluginvalues{"Name"} && $pluginvalues{"Optargs"} && $pluginvalues{"Functionality"} && $pluginvalues{"SWElemID"} && 
            $pluginvalues{"Mode"} && $pluginvalues{"FunctionalityInstanceID"} && $pluginvalues{"IndicationID"} && $pluginvalues{"SourceClass"})
        {
            my $value;
            if (!$pluginvalues{"ProbableCause"})
            {
                $value = "\"Default probable cause $count\"";
                $pluginvalues{"ProbableCause"} = $value;
                print "Argument ProbableCause missing, setting to default value = $value\n";
                $count++;
            }
            if (!$pluginvalues{"Frequency"})
            {
                $value = "5";
                $pluginvalues{"Frequency"} = $value;
                print "Argument Frequency missing, setting to default value = $value\n";    
            }

            my @allkeys = keys %pluginvalues;
            my $mycmd = "./pecconfigure " . $pluginvalues{"Name"} . " " . $pluginvalues{"Optargs"} . " " 
                        . $pluginvalues{"Functionality"} . " " . $pluginvalues{"SWElemID"} 
                        . " " . $pluginvalues{"Mode"} . " " . $pluginvalues{"FunctionalityInstanceID"}
                        . " " . $pluginvalues{"IndicationID"} . " " . $pluginvalues{"ProbableCause"} 
                        . " " . $pluginvalues{"Frequency"} . " " . $pluginvalues{"SourceClass"} ;
            print "COMMAND: $mycmd\n\n";
            system $mycmd;
        }
        else
        {
            print "Critical arguments missing, skipping to next plugin\n";
        }
    }
    else
    {
        $line = <MYFILE>;
    }    
}

close MYFILE;
