/*Note from the Author
*/

#define OPT_AND_ARGS_LEN 256
#define INDICATION_ID_LEN 20
#define PLUGIN_NAME_LEN 256
#define PROB_CAUSE_LEN 256
#define SRC_CLASS_LEN 256
#define STRING_LEN 1024

typedef enum {ALL = 0, GET = 1, INDICATION = 2} functionalityMode_t;

typedef struct
{
    char pluginName[PLUGIN_NAME_LEN + 1];
    char indicationIdentifier[INDICATION_ID_LEN + 1];
    int  frequency;
    char optAndArgs[OPT_AND_ARGS_LEN + 1];
    char probableCause[PROB_CAUSE_LEN + 1];
} pluginIndicationID_t;

int debugOutput(char *fmt, ...);

int getAllPluginsData(const CMPIBroker *broker,
                      const CMPIContext *ctx,
                      pluginIndicationID_t *N4CPLUGIN_pluginIndicationIDArray, 
                      int arraySize, 
                      int *pluginIndicationIDArrayLen);
int getFilteredPluginsData(const CMPIBroker *broker,
                             const CMPIContext *ctx,
                             pluginIndicationID_t *N4CPLUGIN_pluginIndicationIDArray, 
                             const char *filterString,
                             int *pluginIndicationIDArrayLen);
